package me.totalfreedom.discord;

import me.totalfreedom.discord.listener.AdminChatListener;
import me.totalfreedom.discord.listener.BukkitNative;
import me.totalfreedom.discord.listener.MinecraftListener;
import me.totalfreedom.discord.util.Utilities;
import org.bukkit.plugin.java.JavaPlugin;

public class TFD4J extends JavaPlugin
{
    private Bot bot;
    private Utilities utils;
    private MinecraftListener mc;
    private AdminChatListener ac;

    @Override
    public void onEnable()
    {
        this.bot = new Bot();
        this.utils = new Utilities(this);
        new BukkitNative(this);
        this.mc = new MinecraftListener(this);
        this.ac = new AdminChatListener(this);

        mc.minecraftChatBound();
        ac.adminChatBound();
    }

    @Override
    public void onDisable()
    {
        bot.getClient().onDisconnect().subscribe();
    }

    public Bot getBot()
    {
        return bot;
    }

    public Utilities getUtils()
    {
        return utils;
    }

    public MinecraftListener getMinecraftListener()
    {
        return mc;
    }

    public AdminChatListener getAdminChatListener()
    {
        return ac;
    }
}
