package me.totalfreedom.discord.listener;

import me.totalfreedom.discord.Bot;
import me.totalfreedom.discord.TFD4J;
import me.totalfreedom.totalfreedommod.TotalFreedomMod;
import me.totalfreedom.totalfreedommod.config.ConfigEntry;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.serializer.plain.PlainTextComponentSerializer;
import net.md_5.bungee.api.ChatColor;
import org.bukkit.GameRule;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.player.AsyncPlayerChatEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;

public class BukkitNative implements Listener
{
    private final TotalFreedomMod commons;
    private final Bot bot;
    private final TFD4J tfd4j;

    public BukkitNative(TFD4J tfd4j)
    {
        this.tfd4j = tfd4j;
        this.bot = tfd4j.getBot();
        this.commons = bot.getTFM().getCommons();

        tfd4j.getServer().getPluginManager().registerEvents(this, tfd4j);
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onPlayerJoin(PlayerJoinEvent event)
    {
        if (!commons.al.isVanished(event.getPlayer().getUniqueId()))
        {
            tfd4j.getUtils().messageChatChannel("**"
                    + tfd4j.getUtils().deformat(event.getPlayer().getName())
                    + " joined the server" + "**", true);
        }
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onPlayerLeave(PlayerQuitEvent event)
    {
        if (!commons.al.isVanished(event.getPlayer().getUniqueId()))
        {
            tfd4j.getUtils().messageChatChannel("**"
                    + tfd4j.getUtils().deformat(event.getPlayer().getName())
                    + " left the server" + "**", true);
        }
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onPlayerDeath(PlayerDeathEvent event)
    {
        //Avoiding NPE Unboxing Warnings
        Boolean b = event.getEntity().getWorld().getGameRuleValue(GameRule.SHOW_DEATH_MESSAGES);
        if (b == null || !b)
        {
            return;
        }

        Component deathMessage = event.deathMessage();

        if (deathMessage != null)
        {
            tfd4j.getUtils().messageChatChannel("**"
                    + tfd4j.getUtils().deformat(PlainTextComponentSerializer.plainText().serialize(deathMessage))
                    + "**", true);
        }
    }

    @EventHandler(ignoreCancelled = true)
    public void onAsyncPlayerChat(AsyncPlayerChatEvent event)
    {
        Player player = event.getPlayer();
        String message = event.getMessage();

        if (!ConfigEntry.ADMIN_ONLY_MODE.getBoolean() && !tfd4j.getServer().hasWhitelist()
                && !commons.pl.getPlayer(player).isMuted() && bot != null)
        {
            tfd4j.getUtils().messageChatChannel(player.getName()
                    + " \u00BB "
                    + ChatColor.stripColor(message), true);
        }
    }
}
